﻿var video;
var startbutton;
var stopbutton;
var canvas;
var img;
var ctx;
var localMediaStream;
var videoSources = [];

function getCameras(camerasLoaded)
{
	if (typeof MediaStreamTrack === 'undefined')
		alert('This browser does not support MediaStreamTrack.\n\nTry Chrome Canary.');
	else
		MediaStreamTrack.getSources(camerasLoaded);
}

function initCamera() 
{
	video = document.getElementById('Video').firstChild;
	canvas = document.getElementById('PhotoCanvas').firstChild;
	ctx = canvas.getContext('2d');
	img = document.getElementById('Photo').firstChild;
	localMediaStream = null;
}

function startVideo(videoSource)
{
var constraints = {
    video: {
      optional: [{sourceId: videoSource}]
    }
  };

  if (navigator.getUserMedia) 
    navigator.getUserMedia(constraints, nonwebkitStartVideo, errorCallback);
  else if (navigator.webkitGetUserMedia) 
    navigator.webkitGetUserMedia(constraints, webkitStartVideo, errorCallback);
  else 
    errorCallback({target: video});
}

function nonwebkitStartVideo(stream)
{
    localMediaStream = stream;
    video.src = stream;
    sizeCanvas();
}

function webkitStartVideo(stream)
{
    localMediaStream = stream;
    video.src = window.URL.createObjectURL(stream);
    sizeCanvas();
}

function takePhoto() 
{
  ctx.drawImage(video, 0, 0);
  img.src = canvas.toDataURL('image/png');
}

function stopVideo() 
{
  video.pause();
  if (localMediaStream)
	localMediaStream.stop(); // Doesn't do anything in Chrome.
}

function sizeCanvas() 
{
  // video.onloadedmetadata not firing in Chrome so we have to hack.
  // See crbug.com/110938.
  setTimeout(function() {
    canvas.width = video.videoWidth;
    canvas.height = video.videoHeight;
    img.width = video.videoWidth;
    img.height = video.videoHeight;
  }, 500);
}

function errorCallback(e) 
{
	if (e.code == 1) 
    		alert('User denied access to their camera');
	else
    		alert('getUserMedia() not supported in your browser.');
}
